// -*- C++ -*-
// $Id$

/**
 * Code generated by the The ACE ORB (TAO) IDL Compiler v2.2a_p14
 * TAO and the TAO IDL Compiler have been developed by:
 *       Center for Distributed Object Computing
 *       Washington University
 *       St. Louis, MO
 *       USA
 *       http://www.cs.wustl.edu/~schmidt/doc-center.html
 * and
 *       Distributed Object Computing Laboratory
 *       University of California at Irvine
 *       Irvine, CA
 *       USA
 * and
 *       Institute for Software Integrated Systems
 *       Vanderbilt University
 *       Nashville, TN
 *       USA
 *       http://www.isis.vanderbilt.edu/
 *
 * Information about TAO is available at:
 *     http://www.cs.wustl.edu/~schmidt/TAO.html
 **/

// TAO_IDL - Generated from
// be/be_codegen.cpp:152

#ifndef _TAO_IDL_RTPSSECURITYC_UC5EEP_H_
#define _TAO_IDL_RTPSSECURITYC_UC5EEP_H_

#include /**/ "ace/pre.h"


#include /**/ "ace/config-all.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


#include /**/ "rtps_export.h"
#include "tao/ORB.h"
#include "tao/Basic_Types.h"
#include "dds/DCPS/ZeroCopyInfoSeq_T.h"
#include "tao/String_Manager_T.h"
#include "tao/VarOut_T.h"
#include "tao/Arg_Traits_T.h"
#include "tao/Basic_Arguments.h"
#include "tao/Special_Basic_Arguments.h"
#include "tao/Any_Insert_Policy_T.h"
#include "tao/Basic_Argument_T.h"
#include "tao/Fixed_Size_Argument_T.h"
#include "tao/Var_Size_Argument_T.h"
#include /**/ "tao/Version.h"
#include /**/ "tao/Versioned_Namespace.h"
#include /**/ "dds/Versioned_Namespace.h"

#include "dds/DdsSecurityCoreC.h"
#include "dds/DCPS/RTPS/RtpsCoreC.h"

#if TAO_MAJOR_VERSION != 2 || TAO_MINOR_VERSION != 2 || TAO_BETA_VERSION != 0
#error This file should be regenerated with TAO_IDL
#endif

#if defined (TAO_EXPORT_MACRO)
#undef TAO_EXPORT_MACRO
#endif
#define TAO_EXPORT_MACRO OpenDDS_Rtps_Export

OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL



// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:38

namespace OpenDDS
{

  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:38

  namespace Security
  {

    // TAO_IDL - Generated from
    // be/be_visitor_enum/enum_ch.cpp:47

    enum DiscoveredParticipantDataKind
    {
      DPDK_NONE,
      DPDK_ORIGINAL,
      DPDK_ENHANCED,
      DPDK_SECURE
    };

    typedef DiscoveredParticipantDataKind &DiscoveredParticipantDataKind_out;

    // TAO_IDL - Generated from
    // be/be_type.cpp:261

    struct SPDPdiscoveredParticipantData;

    typedef
      ::TAO_Var_Var_T<
          SPDPdiscoveredParticipantData
        >
      SPDPdiscoveredParticipantData_var;

    typedef
      ::TAO_Out_T<
          SPDPdiscoveredParticipantData
        >
      SPDPdiscoveredParticipantData_out;

    // TAO_IDL - Generated from
    // be/be_visitor_structure/structure_ch.cpp:51

    struct OpenDDS_Rtps_Export SPDPdiscoveredParticipantData
    {

      // TAO_IDL - Generated from
      // be/be_type.cpp:307

      
      typedef SPDPdiscoveredParticipantData_var _var_type;
      typedef SPDPdiscoveredParticipantData_out _out_type;
      
      OpenDDS::Security::DiscoveredParticipantDataKind dataKind;
      DDS::Security::ParticipantBuiltinTopicDataSecure ddsParticipantDataSecure;
      OpenDDS::RTPS::ParticipantProxy_t participantProxy;
      OpenDDS::RTPS::Duration_t leaseDuration;
    };
  
  // TAO_IDL - Generated from
  // be/be_visitor_module/module_ch.cpp:67
  
  } // module OpenDDS::Security

// TAO_IDL - Generated from
// be/be_visitor_module/module_ch.cpp:67

} // module OpenDDS

// TAO_IDL - Generated from
// be/be_visitor_arg_traits.cpp:68


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL


// Arg traits specializations.
namespace TAO
{

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:904

  template<>
  class Arg_Traits< ::OpenDDS::Security::DiscoveredParticipantDataKind>
    : public
        Basic_Arg_Traits_T<
            ::OpenDDS::Security::DiscoveredParticipantDataKind,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };

  // TAO_IDL - Generated from
  // be/be_visitor_arg_traits.cpp:947

  template<>
  class Arg_Traits< ::OpenDDS::Security::SPDPdiscoveredParticipantData>
    : public
        Var_Size_Arg_Traits_T<
            ::OpenDDS::Security::SPDPdiscoveredParticipantData,
            TAO::Any_Insert_Policy_Noop
          >
  {
  };
}

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_traits.cpp:62


OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

// Traits specializations.
namespace TAO
{
}
TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_enum/cdr_op_ch.cpp:37



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Rtps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &strm, OpenDDS::Security::DiscoveredParticipantDataKind _tao_enumerator);
OpenDDS_Rtps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &strm, OpenDDS::Security::DiscoveredParticipantDataKind &_tao_enumerator);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_visitor_structure/cdr_op_ch.cpp:46



OPENDDS_END_VERSIONED_NAMESPACE_DECL


TAO_BEGIN_VERSIONED_NAMESPACE_DECL

OpenDDS_Rtps_Export ::CORBA::Boolean operator<< (TAO_OutputCDR &, const OpenDDS::Security::SPDPdiscoveredParticipantData &);
OpenDDS_Rtps_Export ::CORBA::Boolean operator>> (TAO_InputCDR &, OpenDDS::Security::SPDPdiscoveredParticipantData &);

TAO_END_VERSIONED_NAMESPACE_DECL


OPENDDS_BEGIN_VERSIONED_NAMESPACE_DECL




// TAO_IDL - Generated from
// be/be_codegen.cpp:1703


OPENDDS_END_VERSIONED_NAMESPACE_DECL

#if defined (__ACE_INLINE__)
#include "RtpsSecurityC.inl"
#endif /* defined INLINE */

#include /**/ "ace/post.h"

#endif /* ifndef */

